summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
Diffstat (limited to 'tests')
-rwxr-xr-xtests/fmt/base.pl6
-rw-r--r--tests/local.mk3
-rwxr-xr-xtests/ls/hex-option.sh (renamed from tests/misc/shred-negative.sh)10
-rwxr-xr-xtests/misc/shred-size.sh34
-rwxr-xr-xtests/misc/stty-row-col.sh2
-rwxr-xr-xtests/misc/tail.pl12
-rwxr-xr-xtests/pr/pr-tests.pl10
-rwxr-xr-xtests/split/l-chunk.sh7
8 files changed, 61 insertions, 23 deletions
diff --git a/tests/fmt/base.pl b/tests/fmt/base.pl
index c6b978785..8751119f1 100755
--- a/tests/fmt/base.pl
+++ b/tests/fmt/base.pl
@@ -26,9 +26,11 @@ my @Tests =
{IN=> "ça\nçb\n"},
{OUT=>"ça b\n"}],
['wide-1', '-w 32768',
- {ERR => "fmt: invalid width: '32768'\n"}, {EXIT => 1}],
+ {ERR => "fmt: invalid width: '32768'"}, {EXIT => 1},
+ {ERR_SUBST => 's/:[^:]*$//'}],
['wide-2', '-w 2147483647',
- {ERR => "fmt: invalid width: '2147483647'\n"}, {EXIT => 1}],
+ {ERR => "fmt: invalid width: '2147483647'"}, {EXIT => 1},
+ {ERR_SUBST => 's/:[^:]*$//'}],
['bad-suffix', '-72x', {IN=> ''},
{ERR => "fmt: invalid width: '72x'\n"}, {EXIT => 1}],
['no-file', 'no-such-file',
diff --git a/tests/local.mk b/tests/local.mk
index 349e322b0..6aec69b0a 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -320,9 +320,9 @@ all_tests = \
tests/misc/sha384sum.pl \
tests/misc/sha512sum.pl \
tests/misc/shred-exact.sh \
- tests/misc/shred-negative.sh \
tests/misc/shred-passes.sh \
tests/misc/shred-remove.sh \
+ tests/misc/shred-size.sh \
tests/misc/shuf.sh \
tests/misc/shuf-reservoir.sh \
tests/misc/sort.pl \
@@ -557,6 +557,7 @@ all_tests = \
tests/ls/file-type.sh \
tests/ls/follow-slink.sh \
tests/ls/getxattr-speedup.sh \
+ tests/ls/hex-option.sh \
tests/ls/infloop.sh \
tests/ls/inode.sh \
tests/ls/m-option.sh \
diff --git a/tests/misc/shred-negative.sh b/tests/ls/hex-option.sh
index 86cbf3e02..0a684b06e 100755
--- a/tests/misc/shred-negative.sh
+++ b/tests/ls/hex-option.sh
@@ -1,5 +1,5 @@
#!/bin/sh
-# Exercise shred -s-3 FILE
+# accept hex/oct numbers to -w and -T
# Copyright (C) 2014 Free Software Foundation, Inc.
@@ -17,12 +17,8 @@
# along with this program. If not, see <http://www.gnu.org/licenses/>.
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
-print_ver_ shred
+print_ver_ ls
-echo 'shred: -2: invalid file size' > exp || framework_failure_
-echo 1234 > f || framework_failure_
-
-shred -s-2 f 2>err && fail=1
-compare exp err || fail=1
+ls -x -T0x10 -w010 || fail=1
Exit $fail
diff --git a/tests/misc/shred-size.sh b/tests/misc/shred-size.sh
new file mode 100755
index 000000000..9eabf606c
--- /dev/null
+++ b/tests/misc/shred-size.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+# Exercise shred --size
+
+# Copyright (C) 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ shred
+
+# Negative size
+echo "shred: invalid file size: '-2'" > exp || framework_failure_
+echo 1234 > f || framework_failure_
+shred -s-2 f 2>err && fail=1
+compare exp err || fail=1
+
+# Octal/Hex
+shred -s010 f || fail=1
+test $(stat --printf=%s f) = 8 || fail=1
+shred -s0x10 f || fail=1
+test $(stat --printf=%s f) = 16 || fail=1
+
+Exit $fail
diff --git a/tests/misc/stty-row-col.sh b/tests/misc/stty-row-col.sh
index 729d6f913..1c7af1da0 100755
--- a/tests/misc/stty-row-col.sh
+++ b/tests/misc/stty-row-col.sh
@@ -47,6 +47,8 @@ tests='
7 rows_1 1_1
8 columns_80 1_80
9 rows_30 30_80
+10 rows_0x1E 30_80
+11 rows_036 30_80
NA LAST NA
'
set $tests
diff --git a/tests/misc/tail.pl b/tests/misc/tail.pl
index 6798eb05d..adeff6857 100755
--- a/tests/misc/tail.pl
+++ b/tests/misc/tail.pl
@@ -19,7 +19,7 @@
use strict;
my $prog = 'tail';
-my $normalize_filename = {ERR_SUBST => 's/^$prog: .*?:/$prog: -:/'};
+my $normalize_strerror = 's/:[^:]*$//';
# Turn off localization of executable's output.
@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
@@ -59,7 +59,7 @@ my @tv = (
"$prog: cannot open '+cl' for reading: No such file or directory\n"],
['err-2', '-cl', '', '', 1,
- "$prog: l: invalid number of bytes\n"],
+ "$prog: invalid number of bytes: 'l'\n"],
['err-3', '+2cz', '', '', 1,
"$prog: cannot open '+2cz' for reading: No such file or directory\n"],
@@ -72,9 +72,9 @@ my @tv = (
# the diagnostic: 'tail: 99999999999999999999: invalid number of bytes'
# on all systems... probably, for now, maybe.
['err-5', '-c99999999999999999999', '', '', 1,
- "$prog: 99999999999999999999: invalid number of bytes\n"],
+ "$prog: invalid number of bytes: '99999999999999999999'", $normalize_strerror],
['err-6', '-c --', '', '', 1,
- "$prog: -: invalid number of bytes\n", $normalize_filename],
+ "$prog: invalid number of bytes: '-'\n"],
# Same as -n 10
['minus-1', '-', '', '', 0],
@@ -106,10 +106,10 @@ my @Tests;
foreach my $t (@tv)
{
- my ($test_name, $flags, $in, $exp, $ret, $err_msg) = @$t;
+ my ($test_name, $flags, $in, $exp, $ret, $err_msg, $err_sub) = @$t;
my $e = [$test_name, $flags, {IN=>$in}, {OUT=>$exp}];
$ret
- and push @$e, {EXIT=>$ret}, {ERR=>$err_msg};
+ and push @$e, {EXIT=>$ret}, {ERR=>$err_msg}, {ERR_SUBST=>$err_sub};
$test_name =~ /^(obs-plus-|minus-)/
and push @$e, {ENV=>'_POSIX2_VERSION=199209'};
diff --git a/tests/pr/pr-tests.pl b/tests/pr/pr-tests.pl
index 10947ac95..cc2ef38c4 100755
--- a/tests/pr/pr-tests.pl
+++ b/tests/pr/pr-tests.pl
@@ -385,9 +385,11 @@ my @tv = (
['col-long', '-W3 -t -1 --columns=2', "a\nb\nc\n", "a c\nb\n", 0],
# Make sure these fail.
['col-0', '-0', '', '', 1,
- "$prog: invalid number of columns: '0'\n"],
+ "$prog: invalid number of columns: '0'",
+ 's/:[^:]*$//'],
['col-inval', '-'.'9'x100, '', '', 1,
- "$prog: invalid number of columns: '". ('9'x100) ."'\n"],
+ "$prog: invalid number of columns: '". ('9'x100) ."'",
+ 's/:[^:]*$//'],
# Before coreutils-5.3.1, --pages=1:-1 would be treated like
# --pages=1:18446744073709551615.
@@ -427,7 +429,7 @@ my $common_option_prefix = '--date-format="-- Date/Time --" -h x';
my @Tests;
foreach my $t (@tv)
{
- my ($test_name, $flags, $in, $exp, $ret, $err_msg) = @$t;
+ my ($test_name, $flags, $in, $exp, $ret, $err_msg, $err_sub) = @$t;
my $new_ent = [$test_name, $common_option_prefix, $flags];
if (!ref $in)
{
@@ -454,7 +456,7 @@ foreach my $t (@tv)
}
}
$ret
- and push @$new_ent, {EXIT=>$ret}, {ERR=>$err_msg};
+ and push @$new_ent, {EXIT=>$ret}, {ERR=>$err_msg}, {ERR_SUBST=>$err_sub};
push @Tests, $new_ent;
}
diff --git a/tests/split/l-chunk.sh b/tests/split/l-chunk.sh
index 792c55691..39ee4dc03 100755
--- a/tests/split/l-chunk.sh
+++ b/tests/split/l-chunk.sh
@@ -20,7 +20,7 @@
print_ver_ split
# invalid number of chunks
-echo 'split: 1o: invalid number of chunks' > exp
+echo "split: invalid number of chunks: '1o'" > exp
split -n l/1o 2>err && fail=1
compare exp err || fail=1
@@ -53,8 +53,9 @@ lines=\
printf "%s" "$lines" | tr '~' '\n' > in || framework_failure_
-echo 'split: 16: invalid chunk number' > exp
-split -n l/16/15 in 2>err && fail=1
+echo "split: invalid chunk number: '16'" > exp
+split -n l/16/15 in 2>err.t && fail=1
+sed 's/:[^:]*$//' < err.t > err || framework_failure_
compare exp err || fail=1
printf '%s' "\